# UserService | CICADA
Documentation for CICADA

### Hierarchy

- UserService

## Index

### Constructors

- constructor

### Properties

- accounts
- accountsList
- accountsSubject
- actions
- actionsList
- actionsSubject
- categories
- categoriesList
- categoriesSubject
- headers
- keystore
- registry
- signer

### Methods

- addAccount
- approveAction
- changeAccountInfo
- getAccountByAddress
- getAccountByPhone
- getAccountDetailsFromMeta
- getAccountStatus
- getAccountTypes
- getActionById
- getActions
- getCategories
- getCategoryByProduct
- getGenders
- getLockedAccounts
- getTransactionTypes
- init
- loadAccounts
- resetAccountsList
- resetPin
- revokeAction
- searchAccountByName
- updateMeta
- wrap

## Constructors

### constructor

- new UserService(httpClient: HttpClient, loggingService: LoggingService, tokenService: TokenService, authService: AuthService ): UserService

- - Defined in src/app/_services/user.service.ts:41

  #### Parameters

  - ##### httpClient: HttpClient

  - ##### loggingService: LoggingService

  - ##### tokenService: TokenService

  - ##### authService: AuthService

  #### Returns UserService

## Properties

### accounts

accounts: AccountDetails [] = []

- Defined in src/app/_services/user.service.ts:29

### Private accountsList

accountsList: BehaviorSubject< AccountDetails []> = ...

- Defined in src/app/_services/user.service.ts:30

### accountsSubject

accountsSubject: Observable< AccountDetails []> = ...

- Defined in src/app/_services/user.service.ts:33

### actions

actions: any[] = []

- Defined in src/app/_services/user.service.ts:35

### Private actionsList

actionsList: BehaviorSubject<any> = ...

- Defined in src/app/_services/user.service.ts:36

### actionsSubject

actionsSubject: Observable<any[]> = ...

- Defined in src/app/_services/user.service.ts:37

### categories

categories: object = {}

- Defined in src/app/_services/user.service.ts:39

### Private categoriesList

categoriesList: BehaviorSubject<object> = ...

- Defined in src/app/_services/user.service.ts:40

### categoriesSubject

categoriesSubject: Observable<object> = ...

- Defined in src/app/_services/user.service.ts:41

### headers

headers: HttpHeaders = ...

- Defined in src/app/_services/user.service.ts:24

### keystore

keystore: MutableKeyStore

- Defined in src/app/_services/user.service.ts:25

### registry

registry: CICRegistry

- Defined in src/app/_services/user.service.ts:27

### signer

signer: Signer

- Defined in src/app/_services/user.service.ts:26

## Methods

### addAccount

- addAccount(account: AccountDetails, cacheSize: number): void

- - Defined in src/app/_services/user.service.ts:302

  #### Parameters

  - ##### account: AccountDetails

  - ##### cacheSize: number

  #### Returns void

### approveAction

- approveAction(id: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:179

  #### Parameters

  - ##### id: string

  #### Returns Observable<any>

### changeAccountInfo

- changeAccountInfo(address: string, name: string, phoneNumber: string, age: string, type: string, bio: string, gender: string, businessCategory: string, userLocation: string, location: string, locationType: string): Promise<any>

- - Defined in src/app/_services/user.service.ts:72

  #### Parameters

  - ##### address: string

  - ##### name: string

  - ##### phoneNumber: string

  - ##### age: string

  - ##### type: string

  - ##### bio: string

  - ##### gender: string

  - ##### businessCategory: string

  - ##### userLocation: string

  - ##### location: string

  - ##### locationType: string

  #### Returns Promise<any>

### getAccountByAddress

- getAccountByAddress(accountAddress: string, limit?: number): Promise<Observable< AccountDetails >>

- - Defined in src/app/_services/user.service.ts:218

  #### Parameters

  - ##### accountAddress: string

  - ##### limit: number = 100

  #### Returns Promise<Observable< AccountDetails >>

### getAccountByPhone

- getAccountByPhone(phoneNumber: string, limit?: number): Promise<Observable< AccountDetails >>

- - Defined in src/app/_services/user.service.ts:244

  #### Parameters

  - ##### phoneNumber: string

  - ##### limit: number = 100

  #### Returns Promise<Observable< AccountDetails >>

### getAccountDetailsFromMeta

- getAccountDetailsFromMeta(userKey: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:187

  #### Parameters

  - ##### userKey: string

  #### Returns Observable<any>

### getAccountStatus

- getAccountStatus(phone: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:63

  #### Parameters

  - ##### phone: string

  #### Returns Observable<any>

### getAccountTypes

- getAccountTypes(): Observable<any>

- - Defined in src/app/_services/user.service.ts:290

  #### Returns Observable<any>

### getActionById

- getActionById(id: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:175

  #### Parameters

  - ##### id: string

  #### Returns Observable<any>

### getActions

- getActions(): void

- - Defined in src/app/_services/user.service.ts:168

  #### Returns void

### getCategories

- getCategories(): void

- - Defined in src/app/_services/user.service.ts:271

  #### Returns void

### getCategoryByProduct

- getCategoryByProduct(product: string, categories: object): string

- - Defined in src/app/_services/user.service.ts:278

  #### Parameters

  - ##### product: string

  - ##### categories: object

  #### Returns string

### getGenders

- getGenders(): Observable<any>

- - Defined in src/app/_services/user.service.ts:298

  #### Returns Observable<any>

### getLockedAccounts

- getLockedAccounts(offset: number, limit: number): Observable<any>

- - Defined in src/app/_services/user.service.ts:68

  #### Parameters

  - ##### offset: number

  - ##### limit: number

  #### Returns Observable<any>

### getTransactionTypes

- getTransactionTypes(): Observable<any>

- - Defined in src/app/_services/user.service.ts:294

  #### Returns Observable<any>

### init

- init(): Promise<void>

- - Defined in src/app/_services/user.service.ts:50

  #### Returns Promise<void>

### loadAccounts

- loadAccounts(limit?: number, offset?: number): Promise<void>

- - Defined in src/app/_services/user.service.ts:205

  #### Parameters

  - ##### limit: number = 100

  - ##### offset: number = 0

  #### Returns Promise<void>

### resetAccountsList

- resetAccountsList(): void

- - Defined in src/app/_services/user.service.ts:262

  #### Returns void

### resetPin

- resetPin(phone: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:58

  #### Parameters

  - ##### phone: string

  #### Returns Observable<any>

### revokeAction

- revokeAction(id: string): Observable<any>

- - Defined in src/app/_services/user.service.ts:183

  #### Parameters

  - ##### id: string

  #### Returns Observable<any>

### searchAccountByName

- searchAccountByName(name: string): any

- - Defined in src/app/_services/user.service.ts:267

  #### Parameters

  - ##### name: string

  #### Returns any

### updateMeta

- updateMeta(syncableAccount: Syncable, accountKey: string, headers: HttpHeaders): Promise<any>

- - Defined in src/app/_services/user.service.ts:153

  #### Parameters

  - ##### syncableAccount: Syncable

  - ##### accountKey: string

  - ##### headers: HttpHeaders

  #### Returns Promise<any>

### wrap

- wrap(syncable: Syncable, signer: Signer ): Promise<Envelope>

- - Defined in src/app/_services/user.service.ts:191

  #### Parameters

  - ##### syncable: Syncable

  - ##### signer: Signer

  #### Returns Promise<Envelope>

Generated using TypeDoc